package kr.co.vividnext.sodalive.point

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.point.QPointGrantLog.pointGrantLog
import org.springframework.data.jpa.repository.JpaRepository

interface PointGrantLogRepository : JpaRepository<PointGrantLog, Long>, PointGrantLogQueryRepository

interface PointGrantLogQueryRepository {
    fun existsByMemberIdAndPolicyId(memberId: Long, policyId: Long): Boolean
}

class PointGrantLogQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : PointGrantLogQueryRepository {
    override fun existsByMemberIdAndPolicyId(memberId: Long, policyId: Long): Boolean {
        return queryFactory
            .select(pointGrantLog.id)
            .from(pointGrantLog)
            .where(
                pointGrantLog.memberId.eq(memberId),
                pointGrantLog.policyId.eq(policyId)
            )
            .fetch()
            .isNotEmpty()
    }
}
